<template>
  <div class="page">
    <div class="ele-body">
      <a-card :bordered="false" :body-style="{ padding: '16px' }">
        <ele-pro-table
          ref="tableRef"
          row-key="bookingVipId"
          :columns="columns"
          :datasource="datasource"
          :customRow="customRow"
          :scroll="{ x: 2800 }"
          tool-class="ele-toolbar-form"
          class="sys-org-table"
        >
          <template #toolbar>
            <search
              @search="reload"
              :selection="selection"
              @add="openEdit"
              @remove="removeBatch"
              @batchMove="openMove"
            />
          </template>
          <template #bodyCell="{ column, record }">
            <template v-if="column.key === 'image'">
              <a-image :src="record.image" :width="50" />
            </template>
            <template v-if="column.key === 'status'">
              <a-tag v-if="record.status === 0" color="green">显示</a-tag>
              <a-tag v-if="record.status === 1" color="red">隐藏</a-tag>
            </template>
            <template v-if="column.key === 'action'">
              <a-space>
                <a-button type="primary" @click="openEdit(record)"
                  >修改</a-button
                >
                <a-popconfirm
                  title="确定要删除此记录吗？"
                  @confirm="remove(record)"
                >
                  <a-button class="ele-text-danger">删除</a-button>
                </a-popconfirm>
              </a-space>
            </template>
          </template>
        </ele-pro-table>
      </a-card>

      <!-- 编辑弹窗 -->
      <BookingVipEdit
        v-model:visible="showEdit"
        :data="current"
        @done="reload"
      />
    </div>
  </div>
</template>

<script lang="ts" setup>
  import { createVNode, ref } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import { ExclamationCircleOutlined } from '@ant-design/icons-vue';
  import type { EleProTable } from 'ele-admin-pro';
  import { toDateString } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import BookingVipEdit from './components/bookingVipEdit.vue';
  import {
    pageBookingVip,
    removeBookingVip,
    removeBatchBookingVip
  } from '@/api/booking/bookingVip';
  import type {
    BookingVip,
    BookingVipParam
  } from '@/api/booking/bookingVip/model';

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);

  // 表格选中数据
  const selection = ref<BookingVip[]>([]);
  // 当前编辑数据
  const current = ref<BookingVip | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    return pageBookingVip({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: '操作',
      key: 'action',
      width: 220,
      fixed: 'left',
      align: 'center'
    },
    {
      title: '会员卡名称',
      dataIndex: 'name',
      key: 'name',
      align: 'center'
    },
    {
      title: '可用场地',
      dataIndex: 'sid',
      key: 'sid',
      align: 'center'
    },
    {
      title: '购买价格',
      dataIndex: 'price',
      key: 'price',
      align: 'center'
    },
    // {
    //   title: '会员卡说明',
    //   dataIndex: 'info',
    //   key: 'info',
    //   align: 'center',
    // },
    {
      title: '折扣率',
      dataIndex: 'discount',
      key: 'discount',
      align: 'center'
    },
    {
      title: '可使用次数',
      dataIndex: 'count',
      key: 'count',
      align: 'center'
    },
    {
      title: '每使用一次减少的金额',
      dataIndex: 'eachMoney',
      key: 'eachMoney',
      align: 'center'
    },
    {
      title: '年限',
      dataIndex: 'term',
      key: 'term',
      align: 'center'
    },
    {
      title: '月限',
      dataIndex: 'month',
      key: 'month',
      align: 'center'
    },
    {
      title: '日限',
      dataIndex: 'day',
      key: 'day',
      align: 'center'
    },
    {
      title: '是否有效',
      dataIndex: 'isUse',
      key: 'isUse',
      align: 'center'
    },
    {
      title: '会员卡类型',
      dataIndex: 'type',
      key: 'type',
      align: 'center'
    },
    {
      title: '卡类型',
      dataIndex: 'cardType',
      key: 'cardType',
      align: 'center'
    },
    {
      title: 'vip卡类型',
      dataIndex: 'vipType',
      key: 'vipType',
      align: 'center'
    },
    {
      title: '排序',
      dataIndex: 'sortNumber',
      key: 'sortNumber',
      align: 'center'
    },
    // {
    //   title: '特殊卡开发凭证图',
    //   dataIndex: 'pic',
    //   key: 'pic',
    //   align: 'center',
    // },
    // {
    //   title: 'VIP充值卡价格组',
    //   dataIndex: 'prices',
    //   key: 'prices',
    //   align: 'center',
    // },
    {
      title: '是否赠送积分',
      dataIndex: 'isIntegral',
      key: 'isIntegral',
      align: 'center'
    },
    {
      title: '创建时间',
      dataIndex: 'createTime',
      key: 'createTime',
      align: 'center',
      sorter: true,
      customRender: ({ text }) => toDateString(text, 'yyyy-MM-dd HH:mm:ss')
    }
  ]);

  /* 搜索 */
  const reload = (where?: BookingVipParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: BookingVip) => {
    current.value = row ?? null;
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: BookingVip) => {
    const hide = message.loading('请求中..', 0);
    removeBookingVip(row.bookingVipId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchBookingVip(selection.value.map((d) => d.bookingVipId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  /* 查询 */
  const query = () => {
    loading.value = true;
  };

  /* 自定义行属性 */
  const customRow = (record: BookingVip) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };
  query();
</script>

<script lang="ts">
  export default {
    name: 'BookingVip'
  };
</script>

<style lang="less" scoped></style>
